chiark / gitweb /
test suite: tar up the artifacts, and name the tarball after the test
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 cwd: $PWD
16 funcs: ${FUNCNAME[*]}
17 lines: ${BASH_LINENO[*]}
18 files: ${BASH_SOURCE[*]}
19 END
20         t-save-artifacts
21
22         exit 16
23 }
24
25 trap 'test $? = 0 || t-report-failure' EXIT
26
27 t-filter-out-git-hyphen-dir
28
29 t-set-intree
30
31 : ${DGIT_TEST_DEBUG=-D}
32 export DGIT_TEST_DEBUG
33
34 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
35
36 export GIT_COMMITTER_DATE='1515000000 +0100'
37 export GIT_AUTHOR_DATE='1515000000 +0100'
38
39 root=`pwd`
40 troot=$root/tests
41 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
42 export DGIT_TEST_TROOT=$troot
43
44 tmp=$ADTTMP
45 if [ x"$tmp" = x ]; then
46         export DGIT_TEST_BYHAND=1
47         mkdir -p tests/tmp
48         tmpbase=$troot/tmp
49         tmp=tests/tmp/$testname
50         rm -rf $tmp
51         mkdir $tmp
52 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
53         tmpbase="$DGIT_TEST_TMPBASE"
54 fi
55 cd $tmp
56
57 tmp=`pwd`
58
59 t-set-using-tmp
60
61 test -f $tmp/.save-env || \
62 env -0 >$tmp/.save-env
63
64 ln -f $troot/ssh ssh
65
66 export DEBCHANGE_VENDOR=dpkg
67
68 mkdir -p $tmp/incoming
69 cat <<END >$tmp/dput.cf
70 [test-dummy]
71 method                  = local
72 incoming                = $tmp/incoming
73 run_dinstall            = 0
74 END
75
76 : ${t_archive_method:=aq}
77 : ${tagpfx:=archive/test-dummy}
78 : ${suitespecs:=sid:unstable}
79
80 t-git-next-date () {
81         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
82         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
83 }
84
85 t-expect-fail () {
86         local mpat="$1"; shift
87
88         set +o pipefail
89         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
90         local ps="${PIPESTATUS[*]}"
91         set -o pipefail
92
93         case $ps in
94         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
95         *" 0")  ;;
96         *)      fail "tee failed"  ;;
97         esac
98
99         t-grep-mpat "$mpat" $tmp/t.output
100 }
101
102 t-grep-mpat () {
103         local mpat="$1"
104         local file="$2"
105
106         local grepper=fgrep
107         case "$mpat" in
108         [A-Z]:*)
109                 case "$mpat" in
110                 E:*)    grepper=egrep   ;;
111                 F:*)    grepper=fgrep   ;;
112                 *)      fail "bad mpat prefix in $mpat";;
113                 esac
114                 mpat=${mpat#[A-Z]:}
115                 ;;
116         esac
117
118         $grepper -e "$mpat" "$file" ||
119                 fail "message not found"
120 }
121
122 t-expect-push-fail () {
123         local mpat="$1"; shift
124
125         local triedpush; triedpush=`git rev-parse HEAD`
126
127         t-reporefs pre-push
128         t-expect-fail "$mpat"  "$@"
129         t-reporefs post-push
130         diff $tmp/show-refs.{pre,post}-push
131
132         t-git-objects-not-present '' $triedpush
133
134         eval "$t_expect_push_fail_hook"
135 }
136
137 t-git-objects-not-present () {
138         # t-git-objects-not-present GITDIR|'' OBJID [...]
139         # specifying '' means the repo for package $p
140         local gitdir="${1-$dgitrepo}"
141         local obj
142         if ! [ -e "$gitdir" ]; then return; fi
143         for obj in "$@"; do
144                 GIT_DIR=$gitdir \
145                 t-expect-fail 'unable to find' \
146                 git cat-file -t $obj
147         done
148 }
149
150 t-reporefs () {
151         local whichoutput=$1; shift
152         local whichrepo=${1-$dgitrepo}
153         local outputfile="$tmp/show-refs.$whichoutput"
154         (set -e
155          exec >"$outputfile"
156          if test -d $whichrepo; then
157                 cd $whichrepo
158                 git show-ref |t-sort
159         fi)
160 }
161
162 t-untar () {
163         local tarfile=$1.tar
164         local edittree=$1.edit
165         if test -d "$edittree"; then
166                 cp -a "$edittree"/* .
167         else
168                 tar xf "$tarfile"
169         fi
170 }
171
172 t-worktree () {
173         rm -rf $p
174         t-untar $troot/worktrees/${p}_$1
175 }
176
177 t-select-package () {
178         p=$1
179         dgitrepo=$tmp/git/$p.git
180 }
181
182 t-git () {
183         t-select-package $1
184         v=$2
185         mkdir -p $tmp/git
186         local gs=$troot/git-srcs/${p}_$v.git
187         (set -e; cd $tmp/git; t-untar $gs)
188 }
189
190 t-git-none () {
191         mkdir -p $tmp/git
192         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
193 }
194
195 t-salsa-add-remote () {
196         local d=$tmp/salsa/$p
197         mkdir -p $d
198         (set -e; cd $d; git init --bare)
199         git remote add ${1-origin} $d
200 }
201
202 t-git-merge-base () {
203         git merge-base $1 $2 || test $? = 1
204 }
205
206 t-has-ancestor () {
207         # t-has-ancestor ANCESTOR
208         # (CHILD is implicit, HEAD)
209         local now;      now=`git rev-parse HEAD`
210         local ancestor; ancestor=`git rev-parse $1^{}`
211         local mbase;    mbase=`t-git-merge-base $ancestor $now`
212         if [ x$mbase != x$ancestor ]; then
213                 fail "not ff $ancestor..$now, $mbase != $ancestor"
214         fi
215 }
216
217 t-has-parent-or-is () {
218         # t-has-parent-or-is CHILD PARENT
219         local child=$1
220         local parent=$2
221         local parents
222         parents=$(git show --pretty=format:' %P %H ' "$child")
223         parent=$(git rev-parse "$parent~0")
224         case "$parents" in
225         *" $parent "*)  ;;
226         *)      fail "child $child lacks parent $parent" ;;
227         esac
228 }
229
230 t-prep-newpackage () {
231         t-select-package $1
232         v=$2
233         t-archive-none $p
234         t-git-none
235         t-worktree $v
236         cd $p
237         if ! git show-ref --verify --quiet refs/heads/master; then
238                 git branch -m dgit/sid master
239                 git remote rm dgit
240         fi
241         cd ..
242 }
243
244 t-archive-none () {
245         t-select-package $1
246         t-archive-none-$t_archive_method
247 }
248 t-archive-none-aq () {
249         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
250
251         : >$tmp/aq/suites
252         local jsondelim="["
253
254         local suitespec
255         for suitespec in $suitespecs; do
256                 local suite=${suitespec%%:*}
257                 local sname=${suitespec#*:}
258
259                 >$tmp/aq/package.$suite.$p
260                 t-aq-archive-updated $suite $p
261
262                 >$tmp/aq/package.new.$p
263                 t-aq-archive-updated new $p
264
265                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
266
267                 cat <<END >>$tmp/aq/suites
268 $jsondelim
269    {
270       "archive" : "ftp-master",
271       "codename" : "$suite",
272       "components" : [
273          "main",
274          "contrib",
275          "non-free"
276       ],
277       "name" : "$sname",
278       "dakname" : "$sname"
279 END
280
281                 jsondelim="   },"
282
283         done
284         cat <<END >>$tmp/aq/suites
285     }
286 ]
287 END
288 }
289
290 t-aq-archive-updated () {
291         local suite=$1
292         local p=$2
293         local suitedir=$tmp/aq/dsc_in_suite/$suite
294         mkdir -p $suitedir
295         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
296                 use JSON;
297                 use strict;
298                 our @v;
299                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
300                 push @v, {
301                         "version" => "$1",
302                         "sha256sum" => "$2",
303                         "component" => "$3",
304                         "filename" => "$4",
305                 };
306                 END {
307                         my $json = JSON->new->canonical();
308                         print $json->encode(\@v) or die $!;
309                 }
310         '
311 }
312
313 t-archive-process-incoming () {
314         local suite=$1
315         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
316         t-archive-query "$suite"
317 }
318
319 t-archive-query () {
320         local suite=${1-sid}
321         local dscf=main/${p}_${v}.dsc
322         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
323 }
324 t-archive-query-aq () {
325         local suite=$1
326         local p=$2
327         local v=$3
328         local dscf=$4
329         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
330         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
331         t-aq-archive-updated $suite $p
332 }
333
334 t-archive () {
335         t-archive-none $1
336         v=$2
337         local dscf=${p}_$2.dsc
338         rm -f $tmp/mirror/pool/main/${p}_*
339         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
340         t-archive-query $suite
341         rm -rf $tmp/extract
342         mkdir $tmp/extract
343         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
344 }
345
346 t-git-dir-time-passes () {
347         touch -d 'last year' $dgitrepo
348 }
349
350 t-git-dir-check () {
351         local gitdir=$dgitrepo
352         case "$1" in
353         enoent)
354                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
355                 return
356                 ;;
357         public) wantstat='7[75]5' ;;
358         secret) wantstat='7[70]0' ;;
359         *)      fail "$1 t-git-dir-check ?" ;;
360         esac
361         gotstat=`stat -c%a $gitdir`
362         case "$gotstat" in
363         *$wantstat) return ;;
364         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
365         esac
366 }
367
368 t-expect-fsck-fail () {
369         echo >>$tmp/fsck.expected-errors "$1"
370 }
371
372 t-git-fsck () {
373         local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
374
375         set +e
376         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
377                 | tee $fsckerrs
378         ps="${PIPESTATUS[*]}"
379         set -e
380
381         local pats
382         if [ -f $tmp/fsck.expected-errors ]; then
383                 pats=(-w -f $tmp/fsck.expected-errors)
384         else
385                 test "$ps" = "0 0"
386         fi
387         pats+=(-e 'notice: HEAD points to an unborn branch')
388         pats+=(-e 'notice: No default references')
389
390         set +e
391         grep -v "${pats[@]}" $fsckerrs
392         rc=$?
393         set -e
394         case $rc in
395         1) ;; # no unexpected errors
396         0) fail "unexpected messages from git-fsck" ;;
397         *) fail "grep of git-fsck failed" ;;
398         esac
399 }
400
401 t-fscks () {
402         (
403         shopt -s nullglob
404         for d in $tmp/*/.git $tmp/git/*.git; do
405                 cd "${d%/.git}"
406                 t-git-fsck
407         done
408         )
409 }
410
411 t-ok () {
412         : '========================================'
413         t-fscks
414         t-save-artifacts
415         echo ok.
416 }
417
418 t-save-artifacts () {
419         artifacts="$AUTOPKGTEST_ARTIFACTS"
420         if [ x"$artifacts" = x ]; then return; fi
421         if [ x"tmp" = x ]; then return; fi
422         : '(((((((((( t-save-artifacts ))))))))))'
423         GZIP=-1v tar -C "$tmp" -zc -f "$artifacts/${0##*/}.tar.gz" \
424                 --exclude=\*.tar .
425         : ')))))))))) t-save-artifacts ))))))))))'
426 }
427
428 t-rm-dput-dropping () {
429         rm -f $tmp/${p}_${v}_*.upload
430 }
431
432 t-dgit () {
433         local dgit=${DGIT_TEST-dgit}
434         pwd >&2
435         : '
436 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
437         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
438  ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
439  ${DGIT_GITDEBREBASE_TEST+--git-debrebase=}${DGIT_GITDEBREBASE_TEST} \
440                 ${distro+${distro:+-d}}${distro--dtest-dummy} \
441                 $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
442                 -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
443         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
444 '
445 }
446
447 t-dgit-manpage () {
448         local section=$1
449         local page=$2
450         (export LC_ALL=C.UTF-8
451          if [ "$DGIT_TEST_INTREE" ]; then
452                 make -C $DGIT_TEST_INTREE $page.$section.view
453          else
454                 man $section $page
455          fi)
456 }
457
458 t-diff-nogit () {
459         diff --exclude=.git --exclude=.pc -ruN $*
460 }
461
462 t-files-notexist () {
463         local f
464         for f in "$@"; do
465                 if [ -e $f ]; then
466                         fail "$f exists!"
467                 fi
468         done
469 }
470
471 t-cloned-fetched-good () {
472         t-diff-nogit ../extract/$p-${v%-*} .
473         t-clean-on-branch dgit/sid
474         t-refs-same-start
475         t-refs-same \
476                 refs/heads/dgit/sid \
477                 refs/remotes/dgit/dgit/sid
478         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
479 }
480
481 t-output () {
482         printf "%s${1:+\n}" "$1" >$tmp/t.want
483         shift
484         "$@" >$tmp/t.got
485         diff $tmp/t.want $tmp/t.got
486 }
487
488 t-clean-on-branch () {
489         t-output "## $1" git status -b --porcelain
490 }
491
492 t-setup-done () {
493         local savevars=$1
494         local savedirs=$2
495         local importeval=$3
496
497         local import=IMPORT.${DGIT_TEST_TESTNAME-${0##*/}}
498         exec 4>$tmp/$import.new
499
500         local vn
501         for vn in $savevars; do
502                 perl >&4 -"I$root" -MDebian::Dgit -e '
503                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
504                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
505         done
506
507         (set -e; cd $tmp; tar cf $import.tar $savedirs)
508
509         printf >&4 "\n%s\n" "$importeval"
510
511         mv -f $tmp/$import.new $tmp/$import
512 }
513
514 t-setup-import () {
515         local setupname=$1
516
517         local setupsrc
518         local lock
519         if [ "x$tmpbase" = x ]; then
520                 # ADTTMP was set on entry to tests/lib, so we
521                 # are not sharing tmp area between tests
522                 setupsrc="$tmp"
523                 lock="$tmp/.dummy.lock"
524         else
525                 setupsrc="$tmpbase/$setupname"
526                 lock="$setupsrc.lock"
527         fi
528
529         local simport="$setupsrc/IMPORT.$setupname"
530
531         if ! [ -e "$simport" ]; then
532                 with-lock-ex -w "$lock" \
533                 xargs -0 -a $tmp/.save-env \
534                 bash -xec '
535                         cd "$1"; shift
536                         setupname="$1"; shift
537                         simport="$1"; shift
538                         if [ -e "$simport" ]; then exit 0; fi
539                         env - "$@" \
540                         "tests/setup/$setupname"
541                 ' x "$root" "$setupname" "$simport"
542         fi
543
544         if [ "x$setupsrc" != "x$tmp" ]; then
545                 (set -e; cd $tmp; tar xf "$simport.tar")
546         fi
547
548         . "$simport"
549 }
550
551 t-git-get-ref-exact () {
552         local ref=$1
553         # does not dereference, unlike t-git-get-ref
554         case "$ref" in
555         refs/*) ;;
556         *) fail "t-git-get-ref-exact bad $ref" ;;
557         esac
558         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
559 }
560
561 t-git-get-ref () {
562         local ref=$1
563         case "$ref" in
564         refs/*) ;;
565         *) fail "t-git-get-ref bad $ref" ;;
566         esac
567         (git show-ref -d $1 || test $? = 1) | perl -ne '
568                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
569                 END { print "$x\n" if length $x; }
570         '
571 }
572
573 t-ref-same-exact () {
574         local name="$1"
575         local val; val=`t-git-get-ref-exact $name`
576         t-ref-same-val "$name" $val
577 }
578
579 t-ref-same () {
580         local name="$1"
581         local val; val=`t-git-get-ref $name`
582         t-ref-same-val "$name" $val
583 }
584
585 t-ref-head () {
586         local val; val=`git rev-parse HEAD`
587         t-ref-same-val HEAD $val
588 }
589
590 t-ref-same-val () {
591         local name="$1"
592         local val=$2
593         case "${t_ref_val-unset}" in
594         unset)          ;;
595         "$val")         ;;
596         *)              fail "ref varies: ($name)\
597  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
598         esac
599         t_ref_val="$val"
600         t_ref_names+=("$name")
601 }
602
603 t-refs-same-start () {
604         unset t_ref_val
605         t_ref_names=()
606 }
607
608 t-refs-same () {
609         local g
610         for g in $*; do
611                 t-ref-same $g
612         done
613 }
614
615 t-refs-notexist () {
616         local val
617         for g in $*; do
618                 val=`t-git-get-ref $g`
619                 if [ "x$val" != x ]; then
620                         fail "ref $g unexpectedly exists ($val)"
621                 fi
622         done
623 }
624
625 t-v-tag () {
626         echo refs/tags/$tagpfx/${v//\~/_}
627 }
628
629 t-format-ref () {
630         git log -n1 --pretty=format:"$1" "$2"
631 }
632
633 t-sametree-parent () {
634         local ref=$1
635         local parent
636         local ctree; ctree=$(t-format-ref '%T' "$ref")
637         while :; do
638                 local psame=''
639                 for parent in $(t-format-ref '%P' "$ref"); do
640                         local ptree; ptree=$(t-format-ref '%T' "$parent")
641                         if [ "x$ptree" = "x$ctree" ]; then
642                                 psame+=" $parent"
643                         fi
644                 done
645                 case "$psame" in ""|" * *") break ;; esac
646                 ref="${psame# }"
647         done
648         echo "$ref"
649 }
650
651 t-check-pushed-master () {
652         local master; master=`t-git-get-ref refs/heads/master`
653         if [ x$master = x$t_ref_val ]; then return; fi
654         if [ x$master = x ]; then fail "failed to push master"; fi
655         # didn't update master, it must be not FF
656         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
657         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
658 }
659
660 t-push-was-source-only () {
661         local f
662         t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
663                          $tmp/incoming/${p}_${v}_*.udeb
664         # we permit _source.buildinfo files; see test_changes_source_only()
665         for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
666             if [ -e $f ]; then
667                 case "$f" in
668                     *_source.buildinfo) ;;
669                     *) fail "non-source-only file $f exists!" ;;
670                 esac
671             fi
672         done
673 }
674
675 t-pushed-good () {
676         local branch=$1
677         local suite=${2:-sid}
678         t-refs-same \
679                 refs/heads/$branch
680         t-pushed-good-core
681 }
682         
683 t-pushed-good-core () {
684         t-ref-dsc-dgit
685         t-refs-same \
686                 `t-v-tag` \
687                 refs/remotes/dgit/dgit/$suite
688         t-refs-notexist \
689                 refs/heads/dgit/unstable \
690                 refs/remotes/dgit/dgit/unstable
691         (set -e; cd $dgitrepo
692          t-refs-same \
693                 refs/dgit/$suite \
694                 `t-v-tag`
695          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
696          t-refs-notexist \
697                 refs/dgit/unstable
698         )
699         git verify-tag `t-v-tag`
700 }
701
702 t-splitbrain-pushed-good--unpack () {
703         cd $tmp
704         rm -rf t-unpack
705         mkdir t-unpack
706         cd t-unpack
707         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
708         ln -s $tmp/incoming/*.orig*.tar* . ||:
709         ln -s $incoming_dsc .
710         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
711         dpkg-source "$@" -x *.dsc
712         cd */.
713         git init
714         git fetch ../../$p "refs/tags/*:refs/tags/*"
715 }
716
717 t-splitbrain-pushed-good--checkprep () {
718         git add -Af .
719         git rm --cached -r --ignore-unmatch .pc
720 }
721
722 t-splitbrain-pushed-good--checkdiff () {
723         local tag=$1
724         t-splitbrain-pushed-good--checkprep
725         t-output "" git diff --stat --cached $tag
726 }
727
728 t-splitbrain-pushed-good-start () {
729         dep14tag=refs/tags/test-dummy/${v//\~/_}
730         dgittag=$(t-v-tag)
731         t-output "" git status --porcelain
732         t-ref-head
733         t-refs-same $dep14tag
734         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
735         git merge-base --is-ancestor $dep14tag $dgittag
736
737         t-refs-same-start
738         t-ref-same refs/heads/split.p
739         case "$(t-git-get-ref refs/heads/split.b)" in
740         "$t_ref_val") ;;
741         "$(git rev-parse refs/heads/split.p^0)") ;;
742         "$(git rev-parse refs/heads/split.p^1)") ;;
743         *) fail 'bad b/p' ;;
744         esac
745         t-pushed-good-core
746
747         t-incoming-dsc
748
749         t-splitbrain-pushed-good--unpack
750         t-splitbrain-pushed-good--checkdiff $dgittag
751 }
752 t-splitbrain-pushed-good-end-made-dep14 () {
753         t-splitbrain-pushed-good--checkdiff $dep14tag
754         cd $tmp/$p
755 }
756
757 t-splitbrain-rm-gitignore-patch () {
758         perl -i -pe '
759                 next unless $_ eq "auto-gitignore\n";
760                 die if $counter++;
761                 chomp;
762                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
763                 $_ = "";
764         ' debian/patches/series
765 }
766
767 t-gbp-pushed-good () {
768         local suite=${1:-sid}
769         t-splitbrain-pushed-good-start
770
771         # Right, now we want to check that the maintainer tree and
772         # the dgit tree differ in exactly the ways we expect.  We
773         # achieve this by trying to reconstruct the maintainer tree
774         # from the dgit tree.
775
776         # So, unpack it withut the patches applied
777         t-splitbrain-pushed-good--unpack --skip-patches
778
779         # dgit might have added a .gitignore patch, which we need to
780         # drop and remove
781         t-splitbrain-rm-gitignore-patch
782
783         # Now the result should differ only in non-debian/ .gitignores
784         t-splitbrain-pushed-good--checkprep
785         git diff --cached --name-only $dep14tag >../changed
786         perl -ne '
787                 next if !m#^debian/# && m#(^|/)\.gitignore#;
788                 die "$_ mismatch";
789         ' <../changed
790
791         # If we actually apply the gitignore patch by hand, it
792         # should be perfect:
793         if [ -f ../t-auto-gitignore ]; then
794                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
795         fi
796
797         t-splitbrain-pushed-good-end-made-dep14
798 }
799
800 t-unapplied-pushed-good () {
801         t-splitbrain-pushed-good-start
802         t-splitbrain-pushed-good--unpack --skip-patches
803         t-splitbrain-pushed-good-end-made-dep14
804 }
805
806 t-dpm-pushed-good () {
807         t-splitbrain-pushed-good-start
808         t-splitbrain-pushed-good--unpack
809         t-splitbrain-rm-gitignore-patch
810         t-splitbrain-pushed-good-end-made-dep14
811 }
812
813 t-commit-build-push-expect-log () {
814         local msg=$1
815         local mpat=$2
816         t-commit "$msg"
817         t-dgit build
818         LC_MESSAGES=C \
819         t-dgit push --new 2>&1 |tee $tmp/push.log
820         t-grep-mpat "$mpat" $tmp/push.log
821 }
822
823 t-822-field () {
824         local file=$1
825         local field=$2
826         perl -e '
827                 use Dpkg::Control::Hash;
828                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
829                 $h->parse(\*STDIN,"'"$file"'");
830                 my $val = $h->{"'$field'"},"\n";
831                 die "'"$file $field"'" unless defined $val;
832                 print $val,"\n";
833         ' <$file
834 }
835
836 t-defdistro () {
837         export DGIT_TEST_DISTRO=''
838         distro=''
839         t-git-config dgit-suite.unstable.distro test-dummy
840 }
841
842 t-stunt-envvar () {
843         local var=$1
844         local tstunt=$2
845         eval '
846                 case "$'$var'" in
847                 "$tstunt:"*)    ;;
848                 *":$tstunt:"*)  ;;
849                 "")             '$var'="$tstunt" ;;
850                 *)              '$var'="$tstunt:$'$var'" ;;
851                 esac
852                 export '$var'
853         '
854 }
855
856 t-tstunt--save-real () {
857         local f="$1"
858         case "$f" in
859         */*) return ;;
860         esac
861
862         local rc
863         local real
864         set +e
865         real=$(
866                 p=":$PATH:"
867                 p="${p/:"$tmp/tstunt":/:}"
868                 p="${p%:}"
869                 p="${p#:}"
870                 PATH="$p"
871                 type -p "$f"
872         )
873         rc=$?
874         set -e
875
876         case $rc in
877         1)      return ;;
878         0)      ;;
879         *)      fail "did not find $f on PATH $PATH" ;;
880         esac
881
882         local varname=${f//[^_0-9a-zA-Z]/_}
883         varname=DGIT_TEST_REAL_${varname^^}
884
885         eval "
886                 : \${$varname:=\$real}
887                 export $varname
888         "
889 }
890
891 t-tstunt () {
892         local tstunt=$tmp/tstunt
893         t-stunt-envvar PATH $tstunt
894         t-stunt-envvar PERLLIB $tstunt
895         local f
896         for f in "$@"; do
897                 t-tstunt--save-real $f
898                 f="./$f"
899                 local d="$tstunt/${f%/*}"
900                 mkdir -p $d
901                 ln -sf "$troot/tstunt/$f" "$d"/.
902         done
903 }
904
905 t-tstunt-parsechangelog () {
906         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
907 }
908
909 t-tstunt-lintian () {
910         t-tstunt lintian
911 }
912
913 t-tstunt-debuild () {
914         t-tstunt debuild
915 }
916
917 t-incoming-dsc () {
918         local dsc=${p}_${v}.dsc
919         incoming_dsc=$tmp/incoming/$dsc
920 }
921
922 t-ref-dsc-dgit () {
923         t-incoming-dsc
924         local val; val=`t-822-field $incoming_dsc Dgit`
925         val=$( perl -e '
926                 $_=shift @ARGV;
927                 die "Dgit $_ ?" unless m/^\w+\b/;
928                 print $&,"\n" or die $!;
929         ' "$val")
930         t-ref-same-val $incoming_dsc "$val"
931 }
932
933 t-apply-diff () {
934         local v1=$1
935         local v2=$2
936         (cd $troot/pkg-srcs;
937          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
938          | patch -p1 -u
939 }
940
941 t-gbp-unapplied-pq2qc () {
942         # does `gbp pq export'
943         # commits the resulting debian/patches on  qc/BRANCH
944         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
945         # qc/BRANCH is not fast-forwarding
946
947         gbp pq export
948
949         branch=`git symbolic-ref HEAD`
950         branch=${branch#refs/heads/}
951
952         case "$branch" in
953         */*) fail "unexpected branch $branch" ;;
954         esac
955
956         git branch -f qc/$branch
957         git checkout qc/$branch
958         git add debian/patches
959         git commit -m 'Commit patch queue'
960 }
961
962 t-git-pseudo-merge () {
963         # like   git merge -s ours
964         if [ ! "$git_pseuomerge_opts" ]; then
965                 if git merge --help \
966                  | grep -q allow-unrelated-histories; then
967                         git_pseuomerge_opts='--allow-unrelated-histories'
968                 fi
969                 git_pseuomerge_opts+=' -s ours'
970         fi
971         git merge $git_pseuomerge_opts "$@"
972 }
973
974 t-gbp-example-prep-no-ff () {
975         t-tstunt-parsechangelog
976         t-archive example 1.0-1
977         t-git-none
978         t-worktree 1.0
979
980         cd example
981
982         t-dgit fetch
983
984         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
985         gbp pq rebase
986
987         echo '/* some comment */' >>src.c
988         git add src.c
989         git commit -m 'Add a comment to an upstream file'
990
991         t-gbp-unapplied-pq2qc
992
993         t-commit 'some updates' 1.0-2
994 }
995
996 t-gbp-example-prep () {
997         t-gbp-example-prep-no-ff
998
999         t-git-pseudo-merge \
1000                 -m 'Pseudo-merge to make descendant of archive' \
1001                 remotes/dgit/dgit/sid
1002 }
1003
1004 t-make-badcommit () {
1005         badcommit=$(
1006                 git cat-file commit HEAD | \
1007                 perl -pe 's/^committer /commiter /' | \
1008                 git hash-object -w -t commit --stdin
1009         )
1010         t-expect-fsck-fail $badcommit
1011 }
1012
1013 t-commit () {
1014         local msg=$1
1015         v=${2:-${majorv:-1}.$revision}
1016         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
1017         git add debian/changelog
1018         debcommit
1019         revision=$(( ${revision-0} + 1 ))
1020 }
1021
1022 t-dch-r-rune () {
1023         local cmd="$1"; shift
1024         local suite=${1-unstable}
1025         $cmd -r -D "$suite" ''
1026 }
1027
1028 t-dch-commit-r () {
1029         t-dch-r-rune t-dch-commit "$@"
1030 }
1031
1032 t-dch-commit () {
1033         faketime @"${GIT_AUTHOR_DATE% *}" dch "$@"
1034         git commit -m "dch $*" debian/changelog
1035 }
1036
1037 t-git-config () {
1038         git config --global "$@"
1039 }
1040
1041 t-drs () {
1042  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
1043  t-git-config dgit-distro.test-dummy.git-check true
1044  t-git-config dgit-distro.test-dummy.git-create true
1045  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
1046         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
1047         cp $troot/suites $tmp/.
1048         cp $troot/suites $tmp/suites-master
1049
1050         export t_check_pushed_master=t-check-pushed-master
1051
1052         drs_dispatch=$tmp/distro=test-dummy
1053         mkdir $drs_dispatch
1054
1055         if [ "x$DGIT_TEST_INTREE" != x ]; then
1056                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
1057         fi
1058
1059         ln -sf $tmp/git $drs_dispatch/repos
1060         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
1061         mkdir -p $drs_dispatch/keyrings
1062         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
1063         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
1064         ln -sf /bin/true $drs_dispatch/policy-hook
1065 }
1066
1067 t-newtag () {
1068  export tagpfx=archive/test-dummy
1069  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
1070 }
1071 t-oldtag () {
1072  export tagpfx=test-dummy
1073  t-git-config dgit-distro.test-dummy.dgit-tag-format old
1074 }
1075
1076 t-dsd () {
1077         t-drs
1078  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
1079  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
1080  t-git-config dgit-distro.test-dummy.git-create true
1081  t-git-config dgit-distro.test-dummy.git-url \
1082                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
1083
1084  t-git-config dgit-distro.test-dummy.diverts.drs /drs
1085  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
1086  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
1087  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
1088  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
1089
1090         echo 'no-such-package* drs' >$drs_dispatch/diverts
1091 }
1092
1093 t-policy-admin () {
1094         : '(((((((((((((((((((((((((((((((((((((((('
1095         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
1096         : '))))))))))))))))))))))))))))))))))))))))'
1097 }
1098
1099 t-policy-nonexist () {
1100         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
1101 }
1102
1103 t-make-hook-link () {
1104         local hook=$1 # in infra/
1105         local linkpath=$2
1106         hook=${DGIT_INFRA_PFX}$hook
1107         case $hook in
1108         */*)    ;;
1109         *)      hook=`type -P $hook` ;;
1110         esac
1111         ln -sf "$hook" $linkpath
1112 }
1113
1114 t-policy () {
1115         local policyhook=$1
1116         t-make-hook-link $policyhook $drs_dispatch/policy-hook
1117 }
1118
1119 t-debpolicy () {
1120         t-dsd
1121         t-policy dgit-repos-policy-debian
1122
1123         mkdir $tmp/git
1124         t-policy-admin create-db
1125 }
1126
1127 t-policy-periodic () {
1128         : '(((((((((((((((((((((((((((((((((((((((('
1129         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1130                 test-dummy $drs_dispatch '' --cron
1131         : '))))))))))))))))))))))))))))))))))))))))'
1132 }
1133
1134 t-restrict () {
1135         local restriction=$1
1136         (cd $root; t-restriction-$restriction >&2)
1137 }
1138
1139 t-dependencies () {
1140         : "Hopefully installed: $*"
1141 }
1142
1143 t-chain-test () {
1144         local ct=$1
1145         local d=${0%/*}
1146         cd $root
1147         export DGIT_TEST_TESTNAME="$testname"
1148         export DGIT_TEST_TMPBASE="$tmpbase"
1149         export ADTTMP=$tmp
1150         exec "$d/$ct"
1151 }       
1152
1153 t-alt-test () {
1154         local t=${0##*/}
1155         t-${t%%-*}
1156         t-chain-test "${t#*-}"
1157 }
1158
1159 t-git-config dgit.default.old-dsc-distro test-dummy
1160
1161 for import in ${autoimport-gnupg}; do
1162         case "$0" in
1163         */$import) ;;
1164         *)
1165                 t-setup-import $import
1166                 ;;
1167         esac
1168 done